package BankApp;


import org.omg.CosNaming.*;

import org.omg.PortableServer.*;
import org.omg.PortableServer.POA;
import java.util.Properties;
import org.omg.CORBA.ORB.*;
import org.omg.CORBA.*;



public class BankUtility
{
	// Debug
	public static final int DEBUG_LEVEL = 0;	// 0: little debug,		1: Reliable Message Level,
												// 2: Packet Level,  	3: Show Packet detail, 
	
	//CONSTANT FOR OPTYPE
	public static final int OPEN=0;
	public static final int DEPOSIT=1;
	public static final int WITHDRAW=2;
	public static final int BALANCE=3;
	public static final int TRANSFER=4;

	//CONSTANT FOR OP_STATUS
	public static final int START=0;
	public static final int SUCCESS=1;
	public static final int FAILED=2;
	//replay only happens when backup becomes primary and try to replay message to finish unfinished transfer
	public static final int REPLAY=3;



	//public static final int BasePortNumber=25000;
	public static final int AMaxBranchNumber=2;
	public static final int MaxBranchNumber=1000;
	public static final int MaxLockTrialNumber=100;

	public static final int MaxTransientRecord=10;

	/////////////////////////////////////////////
	//UDP
	public static final int TimeOutMiliSeconds=1;
	public static final int MaxTrialNumber=1000;
	public static final int MaxUDPConnectionNumber=2000;

	public static final int SleepingLength=1000;
	public static final int WaitingLength=1;
	public static final int WaitingTimes=1500;


	public static final float NegativeInfinite= -10000;
	public static final int InvalidAccountNumber=-1;
	public static final int BranchIDOffset=1;
	public static final int OpIDPrefixLength=21;
	public static final int OpIDSuffixLength=5;
	public static final int OpIDLength=OpIDPrefixLength+OpIDSuffixLength;
	public static String defaultOpID = String.format("%1$" + BankUtility.OpIDLength + "d",0); 

	// public static final int PacketSize=OpIDLength+5*4+2*4+1*8;
	public static final int PacketSize=OpIDLength+5*4+2*4+2*4+1*8;
	
	public static final int BaseReplyPortNumber=27000;
	public static final int MaxReplyPortNumber=27300;

	public static final int ACKNOWLEDGEMENT=10;//used as status in packet
	public static final int REPLY=11;//used as status in packet
	public static final int UDPReceiveBufferSize = 10000;




	//these are four states of primary server
	public static final int NORMAL=0;
	public static final int TRANSIENT=1;
	public static final int SINGLE=2;
	public static final int BACKUPJOIN=3;
	public static final int STATETRANSFER=4;


	//THIS IS MESSAGE SENT TO MONITOR
	public static final int LOAD_BACKUP=4;


	//MESSAGE SENT TO OTHER PRIMARY
	public static final int TRANSFER_CHECK=5;
	public static final int TRANSFER_NORMAL=6;
	public static final int TRANSFER_REJECTED=7;
	public static final int TRANSFER_PREPARED=8;
	

	//MESSAGE RECEIVED FROM BACKUP
	
	public static final int BACKUP_READY=9;
	public static final int REQUEST_JOIN=10010;

	// Bank Account related
	public static final int ACCOUNT_SIZE = 4;
	
	/**
	 * Print debug information
	 * @param debug_level The debug level of this information
	 * @param debugInfo The text message
	 */
	public static void showDebugInfo(int debug_level, String debugInfo){
		if(debug_level<=BankUtility.DEBUG_LEVEL){
			System.out.println(debugInfo);
		}
	}

	/**
	 * Print debug information
	 * @param debug_level The debug level of this information
	 * @param debugInfo The text message
	 * @param packet The packet information
	 */
	public static void showDebugInfo(int debug_level, String debugInfo, Packet packet){
		if(debug_level<=BankUtility.DEBUG_LEVEL){
			if(debugInfo.length()>0) System.out.println(debugInfo);
			if(packet!=null) packet.display();
		}
	}
}


