package ServerConfig;

import ServerConfig.loader.*;
import org.omg.CORBA.ORB;
import org.omg.CosNaming.NameComponent;
import org.omg.CosNaming.NamingContextExt;
import org.omg.CosNaming.NamingContextExtHelper;
import org.omg.PortableServer.POA;
import org.omg.PortableServer.*;

/**
 * @author Min Huang (khtwo)
 * Loader Transient Server
 *
 */
public class LoaderServerTransient {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
	    try{
	        // create and initialize the ORB
	        ORB orb = ORB.init(args, null);

	        // create an implementation and register it with the ORB
	        LoaderServant loaderServant = new LoaderServant(orb);

	        // get reference to rootpoa & activate the POAManager
	        POA rootpoa = POAHelper.narrow(
	          orb.resolve_initial_references("RootPOA"));
	        rootpoa.the_POAManager().activate();

	        // get object reference from the servant
	        org.omg.CORBA.Object ref = 
	          rootpoa.servant_to_reference(loaderServant);
	        ProgramLoader href = ProgramLoaderHelper.narrow(ref);
	  	  
	        // get the root naming context
	        // NameService invokes the name service
	        org.omg.CORBA.Object objRef = 
	          orb.resolve_initial_references("NameService");
	        // Use NamingContextExt which is part of the Interoperable
	        // Naming Service (INS) specification.
	        NamingContextExt ncRef = 
	          NamingContextExtHelper.narrow(objRef);

	        // bind the Object Reference in Naming
	        String name = "loaderTransient";
	        NameComponent path[] = ncRef.to_name( name );
	        ncRef.rebind(path, href);

	        System.out.println("loaderTransient is ready ...");

	        // wait for invocations from clients
	        orb.run();
	      } catch (Exception e) {
	          System.err.println("ERROR: " + e);
	          e.printStackTrace(System.out);
	      }
	      System.out.println(args[0]+" Exiting ....");

	}

}
