package ServerConfig;


public class RegisterProgramLoader {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		ServerConfig currentConfig = new ServerConfig();
		try {
			int stage = 0; // Config reading stage, 0: Totally failed, 1: Get Server cfg, 2: Get Monitor cfg
			// Try to read server config
			try{
				currentConfig.readConfigFromFile(true);
				stage = 1;				
			}catch(Exception e){
				// Read server config failed, try to read monitor config
				try{
					currentConfig.readConfigFromFile(false);
					stage = 2;				
				}catch(Exception f){
					// Read mointor config failed, do nothing and quit
					Runtime.getRuntime().exit(1);					
				}
			}
			stage ++;

			
			String appName = "loader" + currentConfig.branchID + currentConfig.serverID + currentConfig.monitorID;
			try {
				// Start orb broker if it's not started
				System.out.println("Starting local orbd");
				/* Depreciated code
				Runtime.getRuntime().exec("cmd /c start orbd -port " + currentConfig.localNCPort
						+ " -ORBInitialPort " + currentConfig.localNCInitialPort
						+ " -ORBInitialHost " + currentConfig.localhostIP);
				*/
				Runtime.getRuntime().exec("javaw com.sun.corba.se.impl.activation.ORBD"
						+ " -port " + currentConfig.localNCPort
						+ " -ORBInitialPort " + currentConfig.localNCInitialPort
						+ " -ORBInitialHost " + currentConfig.localhostIP);

				// Wait the orbd to start
				Thread.sleep(3000);
				System.out.print("Stopping old loader. ");
				// Stop the older loader
				System.out.println(
				Runtime.getRuntime().exec("java com.sun.corba.se.impl.activation.ServerTool"
						+ " -ORBInitialPort " + currentConfig.localNCInitialPort
						+ " -ORBInitialHost " + currentConfig.localhostIP
						+ " -cmd shutdown -applicationName " + appName).waitFor()==0?"ok":"Error Happened");
				// Unregister the older loader
				System.out.print("Unregistering old loader. ");
				System.out.println(
				Runtime.getRuntime().exec("java com.sun.corba.se.impl.activation.ServerTool"
						+ " -ORBInitialPort " + currentConfig.localNCInitialPort
						+ " -ORBInitialHost " + currentConfig.localhostIP
						+ " -cmd unregister -applicationName " + appName).waitFor()==0?"ok":"Error Happened");
				// Register Persistant Server of local program loader
				System.out.print("Registering new program loader. ");
				System.out.println(
				Runtime.getRuntime().exec("java com.sun.corba.se.impl.activation.ServerTool"
						+ " -ORBInitialPort " + currentConfig.localNCInitialPort
						+ " -ORBInitialHost " + currentConfig.localhostIP
						+ " -cmd register -server ServerConfig.LoaderServer -applicationName "
						+ appName + " -classpath " + currentConfig.currentDirectory
						+ " -args \"" + currentConfig.currentDirectory + "\"").waitFor()==0?"ok":"Error Happened");
				// Start the new loader
				System.out.print("Starting new loader. ");
				System.out.println(
				Runtime.getRuntime().exec("java com.sun.corba.se.impl.activation.ServerTool"
						+ " -ORBInitialPort " + currentConfig.localNCInitialPort
						+ " -ORBInitialHost " + currentConfig.localhostIP
						+ " -cmd startup -applicationName " + appName).waitFor()==0?"ok":"Error Happened");
				
			}
			catch (Exception ex) {
				System.out.println("Local program loader starting failed.");
			}

		}
		catch (Exception e) {
			System.out.println("Error happened when using naming context" + e);
		}
	}

}
